/* Main Simulation File */

#if defined(__cplusplus)
extern "C" {
#endif

#include "WaterTank_TestSingleWaterTank_model.h"
#include "simulation/solver/events.h"


/* dummy VARINFO and FILEINFO */
const FILE_INFO dummyFILE_INFO = omc_dummyFileInfo;
const VAR_INFO dummyVAR_INFO = omc_dummyVarInfo;

int WaterTank_TestSingleWaterTank_input_function(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int WaterTank_TestSingleWaterTank_input_function_init(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int WaterTank_TestSingleWaterTank_input_function_updateStartValues(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int WaterTank_TestSingleWaterTank_inputNames(DATA *data, char ** names){
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int WaterTank_TestSingleWaterTank_data_function(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  TRACE_POP
  return 0;
}

int WaterTank_TestSingleWaterTank_output_function(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}

int WaterTank_TestSingleWaterTank_setc_function(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}


/*
equation index: 19
type: SIMPLE_ASSIGN
tank.valve_powerIn_p = tank.gravity * tank.volume * tank.liquid_density
*/
void WaterTank_TestSingleWaterTank_eqFunction_19(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,19};
  data->localData[0]->realVars[10] /* tank.valve_powerIn_p variable */ = (data->simulationInfo->realParameter[6] /* tank.gravity PARAM */) * ((data->localData[0]->realVars[1] /* tank.volume STATE(1,tank.tank_p_f) */) * (data->simulationInfo->realParameter[8] /* tank.liquid_density PARAM */));
  TRACE_POP
}
/*
equation index: 20
type: SIMPLE_ASSIGN
control1.level = tank.volume / tank.area
*/
void WaterTank_TestSingleWaterTank_eqFunction_20(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,20};
  data->localData[0]->realVars[4] /* control1.level variable */ = DIVISION_SIM(data->localData[0]->realVars[1] /* tank.volume STATE(1,tank.tank_p_f) */,data->simulationInfo->realParameter[2] /* tank.area PARAM */,"tank.area",equationIndexes);
  TRACE_POP
}
/*
equation index: 21
type: SIMPLE_ASSIGN
control1.valve = if control1.level >= control1.maxlevel then 1.0 else if control1.level < control1.minlevel then 0.0 else pre(control1.valve)
*/
void WaterTank_TestSingleWaterTank_eqFunction_21(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,21};
  modelica_boolean tmp0;
  modelica_boolean tmp1;
  modelica_boolean tmp2;
  modelica_real tmp3;
  RELATIONHYSTERESIS(tmp0, data->localData[0]->realVars[4] /* control1.level variable */, data->simulationInfo->realParameter[0] /* control1.maxlevel PARAM */, 2, GreaterEq);
  tmp2 = (modelica_boolean)tmp0;
  if(tmp2)
  {
    tmp3 = 1.0;
  }
  else
  {
    RELATIONHYSTERESIS(tmp1, data->localData[0]->realVars[4] /* control1.level variable */, data->simulationInfo->realParameter[1] /* control1.minlevel PARAM */, 3, Less);
    tmp3 = (tmp1?0.0:data->simulationInfo->realVarsPre[5] /* control1.valve variable */);
  }
  data->localData[0]->realVars[5] /* control1.valve variable */ = tmp3;
  TRACE_POP
}
/*
equation index: 22
type: SIMPLE_ASSIGN
tank.valve_puddle = 8.0 * sqrt(tank.valve_outflow_int)
*/
void WaterTank_TestSingleWaterTank_eqFunction_22(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,22};
  modelica_real tmp4;
  tmp4 = data->localData[0]->realVars[0] /* tank.valve_outflow_int STATE(1,tank.valve_outflow) */;
  if(!(tmp4 >= 0.0))
  {
    FILE_INFO info = {"",0,0,0,0,0};
    omc_assert_warning(info, "The following assertion has been violated %sat time %f", initial() ? "during initialization " : "", data->localData[0]->timeValue);
    throwStreamPrintWithEquationIndexes(threadData, equationIndexes, "Model error: Argument of sqrt(tank.valve_outflow_int) was %g should be >= 0", tmp4);
  }
  data->localData[0]->realVars[13] /* tank.valve_puddle variable */ = (8.0) * (sqrt(tmp4));
  TRACE_POP
}
/*
equation index: 23
type: SIMPLE_ASSIGN
tank.drain_p_e = if control1.valve <> 0.0 then tank.valve_powerIn_p else 0.0
*/
void WaterTank_TestSingleWaterTank_eqFunction_23(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,23};
  data->localData[0]->realVars[6] /* tank.drain_p_e variable */ = ((data->localData[0]->realVars[5] /* control1.valve variable */ != 0.0)?data->localData[0]->realVars[10] /* tank.valve_powerIn_p variable */:0.0);
  TRACE_POP
}
/*
equation index: 24
type: SIMPLE_ASSIGN
tank.valve_powerOut_f = tank.drain_p_e / tank.drain_r
*/
void WaterTank_TestSingleWaterTank_eqFunction_24(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,24};
  data->localData[0]->realVars[12] /* tank.valve_powerOut_f variable */ = DIVISION_SIM(data->localData[0]->realVars[6] /* tank.drain_p_e variable */,data->simulationInfo->realParameter[3] /* tank.drain_r PARAM */,"tank.drain_r",equationIndexes);
  TRACE_POP
}
/*
equation index: 25
type: SIMPLE_ASSIGN
tank.valve_powerIn_phi = if control1.valve <> 0.0 then tank.valve_powerOut_f else 0.0
*/
void WaterTank_TestSingleWaterTank_eqFunction_25(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,25};
  data->localData[0]->realVars[11] /* tank.valve_powerIn_phi variable */ = ((data->localData[0]->realVars[5] /* control1.valve variable */ != 0.0)?data->localData[0]->realVars[12] /* tank.valve_powerOut_f variable */:0.0);
  TRACE_POP
}
/*
equation index: 26
type: SIMPLE_ASSIGN
tank.valve_outflow = if tank.valve_powerOut_f < 0.0 then 0.0 else 0.1 * abs(tank.valve_powerOut_f)
*/
void WaterTank_TestSingleWaterTank_eqFunction_26(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,26};
  modelica_boolean tmp7;
  RELATIONHYSTERESIS(tmp7, data->localData[0]->realVars[12] /* tank.valve_powerOut_f variable */, 0.0, 0, Less);
  data->localData[0]->realVars[9] /* tank.valve_outflow variable */ = (tmp7?0.0:(0.1) * (fabs(data->localData[0]->realVars[12] /* tank.valve_powerOut_f variable */)));
  TRACE_POP
}
/*
equation index: 27
type: SIMPLE_ASSIGN
tank.tank_p_f = tank.fs_phi - tank.valve_powerIn_phi
*/
void WaterTank_TestSingleWaterTank_eqFunction_27(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,27};
  data->localData[0]->realVars[8] /* tank.tank_p_f variable */ = data->simulationInfo->realParameter[5] /* tank.fs_phi PARAM */ - data->localData[0]->realVars[11] /* tank.valve_powerIn_phi variable */;
  TRACE_POP
}
/*
equation index: 28
type: SIMPLE_ASSIGN
$DER.tank.volume = tank.tank_p_f
*/
void WaterTank_TestSingleWaterTank_eqFunction_28(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,28};
  data->localData[0]->realVars[3] /* der(tank.volume) STATE_DER */ = data->localData[0]->realVars[8] /* tank.tank_p_f variable */;
  TRACE_POP
}
/*
equation index: 29
type: SIMPLE_ASSIGN
$DER.tank.valve_outflow_int = tank.valve_outflow
*/
void WaterTank_TestSingleWaterTank_eqFunction_29(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,29};
  data->localData[0]->realVars[2] /* der(tank.valve_outflow_int) STATE_DER */ = data->localData[0]->realVars[9] /* tank.valve_outflow variable */;
  TRACE_POP
}

OMC_DISABLE_OPT
int WaterTank_TestSingleWaterTank_functionDAE(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  int equationIndexes[1] = {0};
#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_tick(SIM_TIMER_DAE);
#endif

  data->simulationInfo->needToIterate = 0;
  data->simulationInfo->discreteCall = 1;
  WaterTank_TestSingleWaterTank_functionLocalKnownVars(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_19(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_20(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_21(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_22(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_23(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_24(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_25(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_26(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_27(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_28(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_29(data, threadData);
  data->simulationInfo->discreteCall = 0;
  
#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_accumulate(SIM_TIMER_DAE);
#endif
  TRACE_POP
  return 0;
}


int WaterTank_TestSingleWaterTank_functionLocalKnownVars(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  
  TRACE_POP
  return 0;
}


/* forwarded equations */
extern void WaterTank_TestSingleWaterTank_eqFunction_19(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_20(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_21(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_23(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_24(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_25(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_26(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_27(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_28(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_29(DATA* data, threadData_t *threadData);

static void functionODE_system0(DATA *data, threadData_t *threadData)
{
    WaterTank_TestSingleWaterTank_eqFunction_19(data, threadData);

    WaterTank_TestSingleWaterTank_eqFunction_20(data, threadData);

    WaterTank_TestSingleWaterTank_eqFunction_21(data, threadData);

    WaterTank_TestSingleWaterTank_eqFunction_23(data, threadData);

    WaterTank_TestSingleWaterTank_eqFunction_24(data, threadData);

    WaterTank_TestSingleWaterTank_eqFunction_25(data, threadData);

    WaterTank_TestSingleWaterTank_eqFunction_26(data, threadData);

    WaterTank_TestSingleWaterTank_eqFunction_27(data, threadData);

    WaterTank_TestSingleWaterTank_eqFunction_28(data, threadData);

    WaterTank_TestSingleWaterTank_eqFunction_29(data, threadData);
}

int WaterTank_TestSingleWaterTank_functionODE(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_tick(SIM_TIMER_FUNCTION_ODE);
#endif

  
  data->simulationInfo->callStatistics.functionODE++;
  
  WaterTank_TestSingleWaterTank_functionLocalKnownVars(data, threadData);
  functionODE_system0(data, threadData);

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_accumulate(SIM_TIMER_FUNCTION_ODE);
#endif

  TRACE_POP
  return 0;
}

/* forward the main in the simulation runtime */
extern int _main_SimulationRuntime(int argc, char**argv, DATA *data, threadData_t *threadData);

#include "WaterTank_TestSingleWaterTank_12jac.h"
#include "WaterTank_TestSingleWaterTank_13opt.h"

struct OpenModelicaGeneratedFunctionCallbacks WaterTank_TestSingleWaterTank_callback = {
   NULL,
   NULL,
   NULL,
   WaterTank_TestSingleWaterTank_callExternalObjectDestructors,
   NULL,
   WaterTank_TestSingleWaterTank_initialLinearSystem,
   NULL,
   #if !defined(OMC_NO_STATESELECTION)
   WaterTank_TestSingleWaterTank_initializeStateSets,
   #else
   NULL,
   #endif
   WaterTank_TestSingleWaterTank_initializeDAEmodeData,
   WaterTank_TestSingleWaterTank_functionODE,
   WaterTank_TestSingleWaterTank_functionAlgebraics,
   WaterTank_TestSingleWaterTank_functionDAE,
   WaterTank_TestSingleWaterTank_functionLocalKnownVars,
   WaterTank_TestSingleWaterTank_input_function,
   WaterTank_TestSingleWaterTank_input_function_init,
   WaterTank_TestSingleWaterTank_input_function_updateStartValues,
   WaterTank_TestSingleWaterTank_data_function,
   WaterTank_TestSingleWaterTank_output_function,
   WaterTank_TestSingleWaterTank_setc_function,
   WaterTank_TestSingleWaterTank_function_storeDelayed,
   WaterTank_TestSingleWaterTank_updateBoundVariableAttributes,
   WaterTank_TestSingleWaterTank_functionInitialEquations,
   1, /* useHomotopy - 0: local homotopy (equidistant lambda), 1: global homotopy (equidistant lambda), 2: new global homotopy approach (adaptive lambda), 3: new local homotopy approach (adaptive lambda)*/
   WaterTank_TestSingleWaterTank_functionInitialEquations_lambda0,
   WaterTank_TestSingleWaterTank_functionRemovedInitialEquations,
   WaterTank_TestSingleWaterTank_updateBoundParameters,
   WaterTank_TestSingleWaterTank_checkForAsserts,
   WaterTank_TestSingleWaterTank_function_ZeroCrossingsEquations,
   WaterTank_TestSingleWaterTank_function_ZeroCrossings,
   WaterTank_TestSingleWaterTank_function_updateRelations,
   WaterTank_TestSingleWaterTank_zeroCrossingDescription,
   WaterTank_TestSingleWaterTank_relationDescription,
   WaterTank_TestSingleWaterTank_function_initSample,
   WaterTank_TestSingleWaterTank_INDEX_JAC_A,
   WaterTank_TestSingleWaterTank_INDEX_JAC_B,
   WaterTank_TestSingleWaterTank_INDEX_JAC_C,
   WaterTank_TestSingleWaterTank_INDEX_JAC_D,
   WaterTank_TestSingleWaterTank_INDEX_JAC_F,
   WaterTank_TestSingleWaterTank_initialAnalyticJacobianA,
   WaterTank_TestSingleWaterTank_initialAnalyticJacobianB,
   WaterTank_TestSingleWaterTank_initialAnalyticJacobianC,
   WaterTank_TestSingleWaterTank_initialAnalyticJacobianD,
   WaterTank_TestSingleWaterTank_initialAnalyticJacobianF,
   WaterTank_TestSingleWaterTank_functionJacA_column,
   WaterTank_TestSingleWaterTank_functionJacB_column,
   WaterTank_TestSingleWaterTank_functionJacC_column,
   WaterTank_TestSingleWaterTank_functionJacD_column,
   WaterTank_TestSingleWaterTank_functionJacF_column,
   WaterTank_TestSingleWaterTank_linear_model_frame,
   WaterTank_TestSingleWaterTank_linear_model_datarecovery_frame,
   WaterTank_TestSingleWaterTank_mayer,
   WaterTank_TestSingleWaterTank_lagrange,
   WaterTank_TestSingleWaterTank_pickUpBoundsForInputsInOptimization,
   WaterTank_TestSingleWaterTank_setInputData,
   WaterTank_TestSingleWaterTank_getTimeGrid,
   WaterTank_TestSingleWaterTank_symbolicInlineSystem,
   WaterTank_TestSingleWaterTank_function_initSynchronous,
   WaterTank_TestSingleWaterTank_function_updateSynchronous,
   WaterTank_TestSingleWaterTank_function_equationsSynchronous,
   WaterTank_TestSingleWaterTank_inputNames,
   WaterTank_TestSingleWaterTank_read_input_fmu,
   NULL,
   NULL,
   -1

};

#define _OMC_LIT_RESOURCE_0_name_data "BouncingBall"
#define _OMC_LIT_RESOURCE_0_dir_data "."
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_0_name,12,_OMC_LIT_RESOURCE_0_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_0_dir,1,_OMC_LIT_RESOURCE_0_dir_data);

#define _OMC_LIT_RESOURCE_1_name_data "Complex"
#define _OMC_LIT_RESOURCE_1_dir_data "/var/lib/jenkins3/ws/OpenModelica_maintenance_v1.16/testsuite/libraries-for-testing/.openmodelica/libraries/Complex 3.2.3+maint.om"
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_1_name,7,_OMC_LIT_RESOURCE_1_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_1_dir,130,_OMC_LIT_RESOURCE_1_dir_data);

#define _OMC_LIT_RESOURCE_2_name_data "FmuExportCrossCompile"
#define _OMC_LIT_RESOURCE_2_dir_data "."
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_2_name,21,_OMC_LIT_RESOURCE_2_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_2_dir,1,_OMC_LIT_RESOURCE_2_dir_data);

#define _OMC_LIT_RESOURCE_3_name_data "Modelica"
#define _OMC_LIT_RESOURCE_3_dir_data "/var/lib/jenkins3/ws/OpenModelica_maintenance_v1.16/testsuite/libraries-for-testing/.openmodelica/libraries/Modelica 3.2.3+maint.om"
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_3_name,8,_OMC_LIT_RESOURCE_3_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_3_dir,131,_OMC_LIT_RESOURCE_3_dir_data);

#define _OMC_LIT_RESOURCE_4_name_data "ModelicaServices"
#define _OMC_LIT_RESOURCE_4_dir_data "/var/lib/jenkins3/ws/OpenModelica_maintenance_v1.16/testsuite/libraries-for-testing/.openmodelica/libraries/ModelicaServices 3.2.3+maint.om"
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_4_name,16,_OMC_LIT_RESOURCE_4_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_4_dir,139,_OMC_LIT_RESOURCE_4_dir_data);

#define _OMC_LIT_RESOURCE_5_name_data "RoomHeating_OM"
#define _OMC_LIT_RESOURCE_5_dir_data "/var/lib/jenkins3/ws/OpenModelica_maintenance_v1.16/testsuite/special/FmuExportCrossCompile"
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_5_name,14,_OMC_LIT_RESOURCE_5_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_5_dir,91,_OMC_LIT_RESOURCE_5_dir_data);

#define _OMC_LIT_RESOURCE_6_name_data "WaterTank"
#define _OMC_LIT_RESOURCE_6_dir_data "/var/lib/jenkins3/ws/OpenModelica_maintenance_v1.16/testsuite/special/FmuExportCrossCompile"
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_6_name,9,_OMC_LIT_RESOURCE_6_name_data);
static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_6_dir,91,_OMC_LIT_RESOURCE_6_dir_data);

static const MMC_DEFSTRUCTLIT(_OMC_LIT_RESOURCES,14,MMC_ARRAY_TAG) {MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_0_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_0_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_1_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_1_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_2_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_2_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_3_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_3_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_4_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_4_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_5_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_5_dir), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_6_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_6_dir)}};
void WaterTank_TestSingleWaterTank_setupDataStruc(DATA *data, threadData_t *threadData)
{
  assertStreamPrint(threadData,0!=data, "Error while initialize Data");
  threadData->localRoots[LOCAL_ROOT_SIMULATION_DATA] = data;
  data->callback = &WaterTank_TestSingleWaterTank_callback;
  OpenModelica_updateUriMapping(threadData, MMC_REFSTRUCTLIT(_OMC_LIT_RESOURCES));
  data->modelData->modelName = "WaterTank.TestSingleWaterTank";
  data->modelData->modelFilePrefix = "WaterTank_TestSingleWaterTank";
  data->modelData->resultFileName = NULL;
  data->modelData->modelDir = "/var/lib/jenkins3/ws/OpenModelica_maintenance_v1.16/testsuite/special/FmuExportCrossCompile";
  data->modelData->modelGUID = "{c8348604-b3c5-4f7f-8f0c-d42f1656d265}";
  data->modelData->initXMLData = NULL;
  data->modelData->modelDataXml.infoXMLData = NULL;
  data->modelData->runTestsuite = 0;
  
  data->modelData->nStates = 2;
  data->modelData->nVariablesReal = 14;
  data->modelData->nDiscreteReal = 0;
  data->modelData->nVariablesInteger = 0;
  data->modelData->nVariablesBoolean = 0;
  data->modelData->nVariablesString = 0;
  data->modelData->nParametersReal = 12;
  data->modelData->nParametersInteger = 0;
  data->modelData->nParametersBoolean = 0;
  data->modelData->nParametersString = 0;
  data->modelData->nInputVars = 0;
  data->modelData->nOutputVars = 0;
  
  data->modelData->nAliasReal = 6;
  data->modelData->nAliasInteger = 0;
  data->modelData->nAliasBoolean = 0;
  data->modelData->nAliasString = 0;
  
  data->modelData->nZeroCrossings = 4;
  data->modelData->nSamples = 0;
  data->modelData->nRelations = 4;
  data->modelData->nMathEvents = 0;
  data->modelData->nExtObjs = 0;
  
  GC_asprintf(&data->modelData->modelDataXml.fileName, "%s/WaterTank_TestSingleWaterTank_info.json", data->modelData->resourcesDir);
  data->modelData->modelDataXml.modelInfoXmlLength = 0;
  data->modelData->modelDataXml.nFunctions = 0;
  data->modelData->modelDataXml.nProfileBlocks = 0;
  data->modelData->modelDataXml.nEquations = 35;
  data->modelData->nMixedSystems = 0;
  data->modelData->nLinearSystems = 1;
  data->modelData->nNonLinearSystems = 0;
  data->modelData->nStateSets = 0;
  data->modelData->nJacobians = 6;
  data->modelData->nOptimizeConstraints = 0;
  data->modelData->nOptimizeFinalConstraints = 0;
  
  data->modelData->nDelayExpressions = 0;
  
  data->modelData->nClocks = 0;
  data->modelData->nSubClocks = 0;
  
  data->modelData->nSensitivityVars = 0;
  data->modelData->nSensitivityParamVars = 0;
  data->modelData->nSetcVars = 0;
  data->modelData->ndataReconVars = 0;
  data->modelData->linearizationDumpLanguage =
  OMC_LINEARIZE_DUMP_LANGUAGE_MODELICA;
}

static int rml_execution_failed()
{
  fflush(NULL);
  fprintf(stderr, "Execution failed!\n");
  fflush(NULL);
  return 1;
}

