/* Linear Systems */
#include "WaterTank_TestSingleWaterTank_model.h"
#include "WaterTank_TestSingleWaterTank_12jac.h"
#if defined(__cplusplus)
extern "C" {
#endif

/* linear systems */

/*
equation index: 5
type: SIMPLE_ASSIGN
control1.valve = if control1.level >= control1.maxlevel then 1.0 else if control1.level < control1.minlevel then 0.0 else $PRE.control1.valve
*/
void WaterTank_TestSingleWaterTank_eqFunction_5(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,5};
  modelica_boolean tmp0;
  modelica_boolean tmp1;
  modelica_boolean tmp2;
  modelica_real tmp3;
  tmp0 = GreaterEq(data->localData[0]->realVars[4] /* control1.level variable */,data->simulationInfo->realParameter[0] /* control1.maxlevel PARAM */);
  tmp2 = (modelica_boolean)tmp0;
  if(tmp2)
  {
    tmp3 = 1.0;
  }
  else
  {
    tmp1 = Less(data->localData[0]->realVars[4] /* control1.level variable */,data->simulationInfo->realParameter[1] /* control1.minlevel PARAM */);
    tmp3 = (tmp1?0.0:data->simulationInfo->realVarsPre[5] /* control1.valve variable */);
  }
  data->localData[0]->realVars[5] /* control1.valve variable */ = tmp3;
  TRACE_POP
}

void residualFunc9(void** dataIn, const double* xloc, double* res, const int* iflag)
{
  TRACE_PUSH
  DATA *data = (DATA*) ((void**)dataIn[0]);
  threadData_t *threadData = (threadData_t*) ((void**)dataIn[1]);
  const int equationIndexes[2] = {1,9};
  ANALYTIC_JACOBIAN* jacobian = NULL;
  data->simulationInfo->realVarsPre[5] /* control1.valve variable */ = xloc[0];
  /* local constraints */
  WaterTank_TestSingleWaterTank_eqFunction_5(data, threadData);
  res[0] = data->localData[0]->realVars[5] /* control1.valve variable */ - data->simulationInfo->realVarsPre[5] /* control1.valve variable */;
  TRACE_POP
}
OMC_DISABLE_OPT
void initializeStaticLSData9(void *inData, threadData_t *threadData, void *systemData)
{
  DATA* data = (DATA*) inData;
  LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;
  int i=0;
  /* static ls data for $PRE.control1.valve */
  linearSystemData->nominal[i] = data->modelData->realVarsData[5].attribute /* control1.valve */.nominal;
  linearSystemData->min[i]     = data->modelData->realVarsData[5].attribute /* control1.valve */.min;
  linearSystemData->max[i++]   = data->modelData->realVarsData[5].attribute /* control1.valve */.max;
}

/* Prototypes for the strict sets (Dynamic Tearing) */

/* Global constraints for the casual sets */
/* function initialize linear systems */
void WaterTank_TestSingleWaterTank_initialLinearSystem(int nLinearSystems, LINEAR_SYSTEM_DATA* linearSystemData)
{
  /* linear systems */
  assertStreamPrint(NULL, nLinearSystems > 0, "Internal Error: indexlinearSystem mismatch!");
  linearSystemData[0].equationIndex = 9;
  linearSystemData[0].size = 1;
  linearSystemData[0].nnz = 0;
  linearSystemData[0].method = 1;   /* Symbolic Jacobian available */
  linearSystemData[0].residualFunc = residualFunc9;
  linearSystemData[0].strictTearingFunctionCall = NULL;
  linearSystemData[0].analyticalJacobianColumn = WaterTank_TestSingleWaterTank_functionJacLSJac3_column;
  linearSystemData[0].initialAnalyticalJacobian = WaterTank_TestSingleWaterTank_initialAnalyticJacobianLSJac3;
  linearSystemData[0].jacobianIndex = 0 /*jacInx*/;
  linearSystemData[0].setA = NULL;  //setLinearMatrixA9;
  linearSystemData[0].setb = NULL;  //setLinearVectorb9;
  linearSystemData[0].initializeStaticLSData = initializeStaticLSData9;
}

#if defined(__cplusplus)
}
#endif

