/* Events: Sample, Zero Crossings, Relations, Discrete Changes */
#include "WaterTank_TestSingleWaterTank_model.h"
#if defined(__cplusplus)
extern "C" {
#endif

/* Initializes the raw time events of the simulation using the now
   calcualted parameters. */
void WaterTank_TestSingleWaterTank_function_initSample(DATA *data, threadData_t *threadData)
{
  long i=0;
}

const char *WaterTank_TestSingleWaterTank_zeroCrossingDescription(int i, int **out_EquationIndexes)
{
  static const char *res[] = {"tank.valve_powerOut_f < 0.0",
  "control1.valve <> 0.0",
  "control1.level >= control1.maxlevel",
  "control1.level < control1.minlevel"};
  static const int occurEqs0[] = {1,26};
  static const int occurEqs1[] = {1,25};
  static const int occurEqs2[] = {1,21};
  static const int occurEqs3[] = {1,21};
  static const int *occurEqs[] = {occurEqs0,occurEqs1,occurEqs2,occurEqs3};
  *out_EquationIndexes = (int*) occurEqs[i];
  return res[i];
}

/* forwarded equations */
extern void WaterTank_TestSingleWaterTank_eqFunction_19(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_20(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_21(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_23(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_24(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_25(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_27(DATA* data, threadData_t *threadData);
extern void WaterTank_TestSingleWaterTank_eqFunction_28(DATA* data, threadData_t *threadData);

int WaterTank_TestSingleWaterTank_function_ZeroCrossingsEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  data->simulationInfo->callStatistics.functionZeroCrossingsEquations++;

  WaterTank_TestSingleWaterTank_eqFunction_19(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_20(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_21(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_23(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_24(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_25(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_27(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_28(data, threadData);
  
  TRACE_POP
  return 0;
}

int WaterTank_TestSingleWaterTank_function_ZeroCrossings(DATA *data, threadData_t *threadData, double *gout)
{
  TRACE_PUSH
  modelica_boolean tmp0;
  modelica_boolean tmp2;
  modelica_boolean tmp3;

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_tick(SIM_TIMER_ZC);
#endif
  data->simulationInfo->callStatistics.functionZeroCrossings++;

  tmp0 = LessZC(data->localData[0]->realVars[12] /* tank.valve_powerOut_f variable */, 0.0, data->simulationInfo->storedRelations[0]);
  gout[0] = (tmp0) ? 1 : -1;
  gout[1] = ((data->localData[0]->realVars[5] /* control1.valve variable */ != 0.0)) ? 1 : -1;
  tmp2 = GreaterEqZC(data->localData[0]->realVars[4] /* control1.level variable */, data->simulationInfo->realParameter[0] /* control1.maxlevel PARAM */, data->simulationInfo->storedRelations[2]);
  gout[2] = (tmp2) ? 1 : -1;
  tmp3 = LessZC(data->localData[0]->realVars[4] /* control1.level variable */, data->simulationInfo->realParameter[1] /* control1.minlevel PARAM */, data->simulationInfo->storedRelations[3]);
  gout[3] = (tmp3) ? 1 : -1;

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_accumulate(SIM_TIMER_ZC);
#endif

  TRACE_POP
  return 0;
}

const char *WaterTank_TestSingleWaterTank_relationDescription(int i)
{
  const char *res[] = {"tank.valve_powerOut_f < 0.0",
  "control1.valve <> 0.0",
  "control1.level >= control1.maxlevel",
  "control1.level < control1.minlevel"};
  return res[i];
}

int WaterTank_TestSingleWaterTank_function_updateRelations(DATA *data, threadData_t *threadData, int evalforZeroCross)
{
  TRACE_PUSH
  modelica_boolean tmp4;
  modelica_boolean tmp6;
  modelica_boolean tmp7;
  
  if(evalforZeroCross) {
    tmp4 = LessZC(data->localData[0]->realVars[12] /* tank.valve_powerOut_f variable */, 0.0, data->simulationInfo->storedRelations[0]);
    data->simulationInfo->relations[0] = tmp4;
    data->simulationInfo->relations[1] = (data->localData[0]->realVars[5] /* control1.valve variable */ != 0.0);
    tmp6 = GreaterEqZC(data->localData[0]->realVars[4] /* control1.level variable */, data->simulationInfo->realParameter[0] /* control1.maxlevel PARAM */, data->simulationInfo->storedRelations[2]);
    data->simulationInfo->relations[2] = tmp6;
    tmp7 = LessZC(data->localData[0]->realVars[4] /* control1.level variable */, data->simulationInfo->realParameter[1] /* control1.minlevel PARAM */, data->simulationInfo->storedRelations[3]);
    data->simulationInfo->relations[3] = tmp7;
  } else {
    data->simulationInfo->relations[0] = (data->localData[0]->realVars[12] /* tank.valve_powerOut_f variable */ < 0.0);
    data->simulationInfo->relations[1] = (data->localData[0]->realVars[5] /* control1.valve variable */ != 0.0);
    data->simulationInfo->relations[2] = (data->localData[0]->realVars[4] /* control1.level variable */ >= data->simulationInfo->realParameter[0] /* control1.maxlevel PARAM */);
    data->simulationInfo->relations[3] = (data->localData[0]->realVars[4] /* control1.level variable */ < data->simulationInfo->realParameter[1] /* control1.minlevel PARAM */);
  }
  
  TRACE_POP
  return 0;
}

#if defined(__cplusplus)
}
#endif

