/* Initialization */
#include "WaterTank_TestSingleWaterTank_model.h"
#include "WaterTank_TestSingleWaterTank_11mix.h"
#include "WaterTank_TestSingleWaterTank_12jac.h"
#if defined(__cplusplus)
extern "C" {
#endif

void WaterTank_TestSingleWaterTank_functionInitialEquations_0(DATA *data, threadData_t *threadData);

/*
equation index: 1
type: SIMPLE_ASSIGN
tank.fs_inflow = if tank.fs_phi < 0.0 then 0.0 else 0.1 * abs(tank.fs_phi)
*/
void WaterTank_TestSingleWaterTank_eqFunction_1(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,1};
  modelica_boolean tmp0;
  tmp0 = Less(data->simulationInfo->realParameter[5] /* tank.fs_phi PARAM */,0.0);
  data->localData[0]->realVars[7] /* tank.fs_inflow variable */ = (tmp0?0.0:(0.1) * (fabs(data->simulationInfo->realParameter[5] /* tank.fs_phi PARAM */)));
  TRACE_POP
}

/*
equation index: 2
type: SIMPLE_ASSIGN
tank.volume = $START.tank.volume
*/
void WaterTank_TestSingleWaterTank_eqFunction_2(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,2};
  data->localData[0]->realVars[1] /* tank.volume STATE(1,tank.tank_p_f) */ = data->modelData->realVarsData[1].attribute /* tank.volume STATE(1,tank.tank_p_f) */.start;
  TRACE_POP
}
extern void WaterTank_TestSingleWaterTank_eqFunction_20(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_19(DATA *data, threadData_t *threadData);


/*
equation index: 9
type: LINEAR

<var>$PRE.control1.valve</var>
<row>

</row>
<matrix>
</matrix>
*/
OMC_DISABLE_OPT
void WaterTank_TestSingleWaterTank_eqFunction_9(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,9};
  /* Linear equation system */
  int retValue;
  double aux_x[1] = { data->simulationInfo->realVarsPre[5] /* control1.valve variable */ };
  if(ACTIVE_STREAM(LOG_DT))
  {
    infoStreamPrint(LOG_DT, 1, "Solving linear system 9 (STRICT TEARING SET if tearing enabled) at time = %18.10e", data->localData[0]->timeValue);
    messageClose(LOG_DT);
  }
  
  retValue = solve_linear_system(data, threadData, 0, &aux_x[0]);
  
  /* check if solution process was successful */
  if (retValue > 0){
    const int indexes[2] = {1,9};
    throwStreamPrintWithEquationIndexes(threadData, indexes, "Solving linear system 9 failed at time=%.15g.\nFor more information please use -lv LOG_LS.", data->localData[0]->timeValue);
  }
  /* write solution */
  data->simulationInfo->realVarsPre[5] /* control1.valve variable */ = aux_x[0];

  TRACE_POP
}
extern void WaterTank_TestSingleWaterTank_eqFunction_23(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_24(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_26(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_29(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_25(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_27(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_28(DATA *data, threadData_t *threadData);


/*
equation index: 17
type: SIMPLE_ASSIGN
tank.valve_outflow_int = $START.tank.valve_outflow_int
*/
void WaterTank_TestSingleWaterTank_eqFunction_17(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,17};
  data->localData[0]->realVars[0] /* tank.valve_outflow_int STATE(1,tank.valve_outflow) */ = data->modelData->realVarsData[0].attribute /* tank.valve_outflow_int STATE(1,tank.valve_outflow) */.start;
  TRACE_POP
}
extern void WaterTank_TestSingleWaterTank_eqFunction_22(DATA *data, threadData_t *threadData);

OMC_DISABLE_OPT
void WaterTank_TestSingleWaterTank_functionInitialEquations_0(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  WaterTank_TestSingleWaterTank_eqFunction_1(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_2(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_20(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_19(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_9(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_23(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_24(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_26(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_29(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_25(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_27(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_28(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_17(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_22(data, threadData);
  TRACE_POP
}


int WaterTank_TestSingleWaterTank_functionInitialEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  data->simulationInfo->discreteCall = 1;
  WaterTank_TestSingleWaterTank_functionInitialEquations_0(data, threadData);
  data->simulationInfo->discreteCall = 0;
  
  TRACE_POP
  return 0;
}


int WaterTank_TestSingleWaterTank_functionInitialEquations_lambda0(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  data->simulationInfo->discreteCall = 1;
  data->simulationInfo->discreteCall = 0;
  
  TRACE_POP
  return 0;
}
int WaterTank_TestSingleWaterTank_functionRemovedInitialEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int *equationIndexes = NULL;
  double res = 0.0;

  
  TRACE_POP
  return 0;
}


#if defined(__cplusplus)
}
#endif

