/* update bound parameters and variable attributes (start, nominal, min, max) */
#include "WaterTank_TestSingleWaterTank_model.h"
#if defined(__cplusplus)
extern "C" {
#endif


/*
equation index: 30
type: SIMPLE_ASSIGN
$START.tank.valve_outflow_int = tank.valve_outflow_int_initial
*/
OMC_DISABLE_OPT
static void WaterTank_TestSingleWaterTank_eqFunction_30(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,30};
  data->modelData->realVarsData[0].attribute /* tank.valve_outflow_int STATE(1,tank.valve_outflow) */.start = data->simulationInfo->realParameter[10] /* tank.valve_outflow_int_initial PARAM */;
    data->localData[0]->realVars[0] /* tank.valve_outflow_int STATE(1,tank.valve_outflow) */ = data->modelData->realVarsData[0].attribute /* tank.valve_outflow_int STATE(1,tank.valve_outflow) */.start;
    infoStreamPrint(LOG_INIT_V, 0, "updated start value: %s(start=%g)", data->modelData->realVarsData[0].info /* tank.valve_outflow_int */.name, (modelica_real) data->localData[0]->realVars[0] /* tank.valve_outflow_int STATE(1,tank.valve_outflow) */);
  TRACE_POP
}

/*
equation index: 31
type: SIMPLE_ASSIGN
$START.tank.volume = tank.volume_initial
*/
OMC_DISABLE_OPT
static void WaterTank_TestSingleWaterTank_eqFunction_31(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,31};
  data->modelData->realVarsData[1].attribute /* tank.volume STATE(1,tank.tank_p_f) */.start = data->simulationInfo->realParameter[11] /* tank.volume_initial PARAM */;
    data->localData[0]->realVars[1] /* tank.volume STATE(1,tank.tank_p_f) */ = data->modelData->realVarsData[1].attribute /* tank.volume STATE(1,tank.tank_p_f) */.start;
    infoStreamPrint(LOG_INIT_V, 0, "updated start value: %s(start=%g)", data->modelData->realVarsData[1].info /* tank.volume */.name, (modelica_real) data->localData[0]->realVars[1] /* tank.volume STATE(1,tank.tank_p_f) */);
  TRACE_POP
}
OMC_DISABLE_OPT
int WaterTank_TestSingleWaterTank_updateBoundVariableAttributes(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  /* min ******************************************************** */
  
  infoStreamPrint(LOG_INIT, 1, "updating min-values");
  if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);
  
  /* max ******************************************************** */
  
  infoStreamPrint(LOG_INIT, 1, "updating max-values");
  if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);
  
  /* nominal **************************************************** */
  
  infoStreamPrint(LOG_INIT, 1, "updating nominal-values");
  if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);
  
  /* start ****************************************************** */
  infoStreamPrint(LOG_INIT, 1, "updating primary start-values");
  WaterTank_TestSingleWaterTank_eqFunction_30(data, threadData);

  WaterTank_TestSingleWaterTank_eqFunction_31(data, threadData);
  if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);
  
  TRACE_POP
  return 0;
}

void WaterTank_TestSingleWaterTank_updateBoundParameters_0(DATA *data, threadData_t *threadData);

/*
equation index: 32
type: SIMPLE_ASSIGN
tank.tank_p_phi = tank.fs_phi
*/
OMC_DISABLE_OPT
static void WaterTank_TestSingleWaterTank_eqFunction_32(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,32};
  data->simulationInfo->realParameter[9] /* tank.tank_p_phi PARAM */ = data->simulationInfo->realParameter[5] /* tank.fs_phi PARAM */;
  TRACE_POP
}

/*
equation index: 33
type: SIMPLE_ASSIGN
tank.fs_p_phi = tank.fs_phi
*/
OMC_DISABLE_OPT
static void WaterTank_TestSingleWaterTank_eqFunction_33(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,33};
  data->simulationInfo->realParameter[4] /* tank.fs_p_phi PARAM */ = data->simulationInfo->realParameter[5] /* tank.fs_phi PARAM */;
  TRACE_POP
}
extern void WaterTank_TestSingleWaterTank_eqFunction_1(DATA *data, threadData_t *threadData);

OMC_DISABLE_OPT
void WaterTank_TestSingleWaterTank_updateBoundParameters_0(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  WaterTank_TestSingleWaterTank_eqFunction_32(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_33(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_1(data, threadData);
  TRACE_POP
}
OMC_DISABLE_OPT
int WaterTank_TestSingleWaterTank_updateBoundParameters(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  WaterTank_TestSingleWaterTank_updateBoundParameters_0(data, threadData);
  TRACE_POP
  return 0;
}

#if defined(__cplusplus)
}
#endif

